install.packages("BiocManager")

unlink("/home/me/src/Rlibs/00LOCK-Rcpp", recursive = TRUE)
options("install.lock"=FALSE)

BiocManager::install("ggtree")

rm(list=ls())

options(scipen = 999)

library(tidytree)
library(tidyr)
library(ggtree)
library(data.tree)
library(RColorBrewer)
library(dplyr)

work.dir=paste0('/eos/jeodpp/home/users/andrrap/data/CASE-STUDY-X-CropDeepTrans/')
df <- read.csv(paste0(work.dir,'data/','HCAT2mergedWithAggregation.csv'))
df_to_plot <-df


df_to_plot$HCAT2_name_aggregated_NL[df_to_plot$HCAT2_name_aggregated_NL=='NA']<-rep('',length(df_to_plot$HCAT2_name_aggregated_NL[df_to_plot$HCAT2_name_aggregated_NL=='NA']))
df_to_plot$crop <- df_to_plot$HCAT2_name_aggregated_NL

#remove first row (characteristics) and remake the pathString
df_to_plot <- df_to_plot[-c(1),]
df_to_plot$pathString <- gsub('/NA','',paste(df_to_plot$level2_name, df_to_plot$level3_name, df_to_plot$level4_name, df_to_plot$level5_name, df_to_plot$level6_name, sep='/'))

#does it matter what var is given to heightName 
df_node_hl <- as.Node(df_to_plot,pathName = "pathString",pathDelimiter = "/",heightName = "hierarchic_level") #8 nodes w/ 344 sub    

df_node_cr <- as.Node(df_to_plot,pathName = "pathString",pathDelimiter = "/",heightName = "crop") #8 nodes w/ 344 sub

df_node <- as.Node(df_to_plot,pathName = "pathString",pathDelimiter = "/") # 8 nodes w/ 344 sub     
## apparently not?


tree <- as.phylo(df_node)

#why does the tree have 344 subs

#column unique value counts? - NO
for(i in 1:ncol(df_to_plot)){
  print(paste0(colnames(df_to_plot)[i], '-' ,n_distinct(df_to_plot[,i])))
}

length(unique(tree$tip.label))
length(unique(df_to_plot$HCAT2_name))

#are all labels from the tree in the HCAT2_name? - YES
unique(tree$tip.label) %in% unique(df_to_plot$HCAT2_name)
#opposite?
unique(df_to_plot$HCAT2_name) %in% unique(tree$tip.label) 
#which mising
sort(unique(df_to_plot$HCAT2_name)[! unique(df_to_plot$HCAT2_name) %in% unique(tree$tip.label)])

#number not the same nrow(df_to_plot) AND length(tree$tip.label)
#reformat the dataframe to fit the size
dat <- data.frame(
  SPECIES = tree$tip.label
  #CROP = sample(df_to_plot$crop, size = length(tree$tip.label)),
  #DISTRO = sample(df_to_plot$distrib_NL, size = length(tree$tip.label))
)

#fit the size 1.1 - works
dat <- merge(dat, df_to_plot[,c(2,3,20,27)], by.x = 'SPECIES', by.y = 'HCAT2_name', all.x = T, all.y = T)
dat <- merge(dat, df_to_plot[,c(2,3,19,22)], by.x = 'SPECIES', by.y = 'HCAT2_name', all.x = T, all.y = T)

#add node number - not the rowid - doesnt work!
# tree_nodes_df <- as.data.frame(tree$node.label)
# colnames(tree_nodes_df) <- 'treeNodeLabel'
# tree_nodes_df$node_id <- row.names(tree_nodes_df)
# 
# dat <- merge(dat, tree_nodes_df, by.x = 'SPECIES', by.y = 'treeNodeLabel', all.x = T)
# colnames(dat) <- c('SPECIES', 'HCAT2_code', 'distrib_NL', 'crop', 'node_id')

#fit the size 2 - doesnt work like this - hue pallette error - why?
#dat <- df_to_plot[df_to_plot$HCAT2_name %in% tree$tip.label,]

#to find nodes
# for(i in 1:400){
#   print(i)
#   
#   p <- ggtree(tree, layout='circular') %<+% dat +
#     geom_nodelab(size=2) + aes(color=HCAT2_name_aggregated_FR)+
#     #geom_tippoint(aes(size=distrib_NL), alpha=.6) +
#     #geom_nodepoint(aes(color=crop, size=distrib_NL, alpha=.6), position = 'identity')+
#     #geom_point2(aes(subset=(node %in% node_id), color = crop, size = distrib_NL))+
#     geom_point2(aes(subset=(node==i), size = 10))+ #alfalfa_lucerne
#     geom_tiplab(offset=.5, size=1)+hexpand(.05)
# 
#   file_name <- paste0('phgen_try_',i,'_.png')
#   plot.dir <- '/eos/jeodpp/data/projects/REFOCUS/data/phylogentree/figs_FR/'
#   ggsave(filename=file_name,plot = p,
#          scale = 1, width = 255, height =150 ,units = "mm",
#          dpi = 300,path=plot.dir)
# }
#193 54 376 250 21 199 363 238 341 400 346 347 369 269 382 63 381 14 2 254 183 176 13 1

hcat2_nodes <- read.csv('/eos/jeodpp/data/projects/REFOCUS/data/phylogentree/HCAT2mergedWithAggregation_nodeid.csv', stringsAsFactors = F)
dat <- merge(dat, hcat2_nodes[,c(3,15)], by.x = 'SPECIES', by.y = 'HCAT2_name', all.x = T, all.y = T)
dat <- merge(dat, hcat2_nodes[,c(3,16)], by.x = 'SPECIES', by.y = 'HCAT2_name', all.x = T, all.y = T)

p <- ggtree(tree, layout='circular') %<+% dat +
  geom_nodelab(size=2) + aes(color=HCAT2_name_aggregated_FR)+
  #geom_tippoint(aes(size=distrib_NL), alpha=.6) +
  #geom_nodepoint(aes(color=crop, size=distrib_NL, alpha=.6), position = 'identity')+
  #geom_point2(aes(node %in% node_id)), color = crop, size = distrib_NL))+
  geom_point2(aes(subset=(node==node), size = distrib_FR))+
  geom_tiplab(offset=.5, size=1)+hexpand(.05)

p <- ggtree(tree, layout='circular') %<+% dat +
  geom_nodelab(size=2) + aes(color=crop)+
  #geom_tippoint(aes(size=distrib_NL), alpha=.6) +
  #geom_nodepoint(aes(color=crop, size=distrib_NL, alpha=.6), position = 'identity')+
  #geom_point2(aes(node %in% node_id)), color = crop, size = distrib_NL))+
  geom_point2(aes(subset=(node==node), size = distrib_NL))+
  geom_point2(aes(subset=(node==345), size = 7422), color = 'black')+
  geom_tiplab(offset=.5, size=1)+hexpand(.05)

file_name <- 'phgen_try1.png'
plot.dir <- '/eos/jeodpp/data/projects/REFOCUS/data/phylogentree/figs/'
ggsave(filename=file_name,plot = p,
       scale = 1, width = 255, height =150 ,units = "mm",
       dpi = 300,path=plot.dir)

ggtree(tree,layout='circular') %<+% df_to_plot +
  geom_nodelab( size=1)


ggtree(tree, layout='circular') %<+% df_to_plot +
  geom_nodelab( size=1)+ aes(color=crop)


ggtree(tree, layout='circular') %<+% df_to_plot +
  geom_nodelab( size=1)+ aes(color=Country) +
  geom_tippoint(aes(size=Distribution), alpha=.6) +
  geom_tiplab(offset=.5, size=1)+hexpand(.05)


###example
data(iris)
rn <- paste0(iris[,5], "_", 1:150)
rownames(iris) <- rn
d_iris <- dist(iris[,-5], method="man")

tree_iris <- ape::bionj(d_iris)
grp <- list(setosa     = rn[1:50],
            versicolor = rn[51:100],
            virginica  = rn[101:150])

p_iris <- ggtree(tree_iris, layout = 'circular', branch.length='none')
groupOTU(p_iris, grp, 'Species') + aes(color=Species) +
  theme(legend.position="right")